<template>
  <div class="app-container">
    <!-- <h1>审课未通过</h1> -->

    <div class="table-container">
      <el-table
        ref="productTable"
        :data="list"
        style="width: 100%"
        @selection-change="handleSelectionChange"
        v-loading="listLoading"
        border
        @sort-change="changeTableSort"
      >
        <!-- <el-table-column
            type="selection"
            width="60"
            align="center"
          ></el-table-column> -->
        <el-table-column label="姓名" align="center">
          <template slot-scope="scope">
            <div
              class="handleStuDetail"
              @click="handleStuDetail(scope.row.userId)"
            >
              {{ scope.row.name }}
            </div>
          </template>
        </el-table-column>

        <el-table-column label="所在学校" align="center">
          <template slot-scope="scope">{{ scope.row.school }}</template>
        </el-table-column>
        <!-- <el-table-column label="年级" align="center">
          <template slot-scope="scope">
            <div v-show="scope.row.grade == 1">大学一年级</div>
            <div v-show="scope.row.grade == 2">大学二年级</div>
            <div v-show="scope.row.grade == 3">大学三年级</div>
            <div v-show="scope.row.grade == 4">大学四年级</div>
            <div v-show="scope.row.grade == 5">大学五年级</div>
          </template>
        </el-table-column> -->
        <el-table-column label="上课学期" align="center">
          <template slot-scope="scope">{{ scope.row.term }}</template>
        </el-table-column>
        <el-table-column label="审课学姐" align="center">
          <template slot-scope="scope">{{ scope.row.auditSenior }}</template>
        </el-table-column>

        <!-- <el-table-column label="审课" align="center">
          <template slot-scope="scope">
            <div
              v-for="(item, index) in scope.row.userCourseList"
              :key="index"
              class="selectClass"
            >
              {{ item.ownCourseCode }}
              <el-select v-if="item.state == 2" v-model="item.state2">
                <el-option
                  label="审课通过"
                  :value="3"
                  :disabled="item.state == 3 || item.state == 4"
                >
                </el-option>
                <el-option
                  label="审课未通过"
                  :value="4"
                  :disabled="item.state == 3 || item.state == 4"
                >
                </el-option>
              </el-select>
            </div>
          </template>
        </el-table-column> -->
        <!-- <div v-for="(item, index) in 3" :key="index"> -->
        <el-table-column label="审课1" align="center">
          <template slot-scope="scope" v-if="scope.row.userCourseList[0]"
            >{{ scope.row.userCourseList[0].ownCourseCode }}
            <el-select
              clearable
              v-if="scope.row.userCourseList[0].state == 2"
              v-model="scope.row.userCourseList[0].state2"
            >
              <el-option label="审课通过" :value="3"> </el-option>
              <el-option label="审课未通过" :value="4"> </el-option>
            </el-select>
            <el-tag
              type="success"
              v-else-if="scope.row.userCourseList[0].state == 3"
              >通过</el-tag
            >
            <el-tag type="danger" v-else>未通过</el-tag>
          </template>
        </el-table-column>
        <el-table-column label="审课2" align="center">
          <template slot-scope="scope" v-if="scope.row.userCourseList[1]"
            >{{ scope.row.userCourseList[1].ownCourseCode }}
            <el-select
              clearable
              v-if="scope.row.userCourseList[1].state == 2"
              v-model="scope.row.userCourseList[1].state2"
            >
              <el-option label="审课通过" :value="3"> </el-option>
              <el-option label="审课未通过" :value="4"> </el-option>
            </el-select>
            <el-tag
              type="success"
              v-else-if="scope.row.userCourseList[1].state == 3"
              >通过</el-tag
            >
            <el-tag type="danger" v-else>未通过</el-tag>
          </template>
        </el-table-column>

        <el-table-column label="审课3" align="center">
          <template slot-scope="scope" v-if="scope.row.userCourseList[2]"
            >{{ scope.row.userCourseList[2].ownCourseCode }}
            <el-select
              clearable
              v-if="scope.row.userCourseList[2].state == 2"
              v-model="scope.row.userCourseList[2].state2"
            >
              <el-option label="审课通过" :value="3"> </el-option>
              <el-option label="审课未通过" :value="4"> </el-option>
            </el-select>
            <el-tag
              type="success"
              v-else-if="scope.row.userCourseList[2].state == 3"
              >通过</el-tag
            >
            <el-tag type="danger" v-else>未通过</el-tag>
          </template>
        </el-table-column>

        <el-table-column label="审课4" align="center">
          <template slot-scope="scope" v-if="scope.row.userCourseList[3]"
            >{{ scope.row.userCourseList[3].ownCourseCode }}
            <el-select
              clearable
              v-if="scope.row.userCourseList[3].state == 2"
              v-model="scope.row.userCourseList[3].state2"
            >
              <el-option label="审课通过" :value="3"> </el-option>
              <el-option label="审课未通过" :value="4"> </el-option>
            </el-select>
            <el-tag
              type="success"
              v-else-if="scope.row.userCourseList[3].state == 3"
              >通过</el-tag
            >
            <el-tag type="danger" v-else>未通过</el-tag>
          </template>
        </el-table-column>

        <el-table-column label="审课5" align="center">
          <template slot-scope="scope" v-if="scope.row.userCourseList[4]"
            >{{ scope.row.userCourseList[4].ownCourseCode }}
            <el-select
              clearable
              v-if="scope.row.userCourseList[4].state == 2"
              v-model="scope.row.userCourseList[4].state2"
            >
              <el-option label="审课通过" :value="3"> </el-option>
              <el-option label="审课未通过" :value="4"> </el-option>
            </el-select>
            <el-tag
              type="success"
              v-else-if="scope.row.userCourseList[4].state == 3"
              >通过</el-tag
            >
            <el-tag type="danger" v-else>未通过</el-tag>
          </template>
        </el-table-column>

        <el-table-column
          label="未通过时间"
          :sortable="'custom'"
          align="center"
          prop="nextChatTime"
        >
          <template slot-scope="scope">{{
            scope.row.updateTime | formatDateTime
          }}</template>
        </el-table-column>

        <!-- <el-table-column
            label="提交时间"
            :sortable="'custom'"
            align="center"
            prop="addTime"
          >
            <template slot-scope="scope">{{ scope.row.addTime }}</template>
          </el-table-column> -->

        <!-- <el-table-column label="选课数量" align="center">
            <template slot-scope="scope">{{
              scope.row.chooseCourseNum
            }}</template>
          </el-table-column> -->

        <!-- <el-table-column label="审课通过数" align="center">
            <template slot-scope="scope">{{ scope.row.passCourseNum }}</template>
          </el-table-column> -->

        <el-table-column label="审课大学" align="center">
          <template slot-scope="scope">{{ scope.row.auditSchool }}</template>
        </el-table-column>

        <el-table-column label="学员状态" align="center">
          <template slot-scope="scope">
            <el-select clearable v-model="scope.row.state">
              <el-option label="待选课" :value="1"> </el-option>
              <el-option label="审核失败" :value="2"> </el-option>
            </el-select>
          </template>
        </el-table-column>

        <el-table-column label="操作" align="center">
          <template slot-scope="scope">
            <el-button
              @click="confirm(scope.row.userCourseList, scope.row.state)"
              type="mini"
              >确认</el-button
            >
            <!-- <el-button @click="confirm(scope.row.userCourseList)" type="mini"
              >确认</el-button
            > -->
          </template>
        </el-table-column>

        <!-- <el-table-column label="最近沟通记录" align="center">
              <template slot-scope="scope">{{ scope.row.context }}</template>
            </el-table-column> -->

        <!-- <el-table-column
              label="下次沟通时间"
              :sortable="'custom'"
              align="center"
              prop="nextChatTime"
            >
              <template slot-scope="scope">{{ scope.row.nextChatTime }}</template>
            </el-table-column> -->
      </el-table>
    </div>

    <div class="pagination-container">
      <el-pagination
        background
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        layout="total,sizes,prev, pager, next,jumper"
        :page-size="pageSize"
        :page-sizes="[5, 10, 15]"
        :current-page.sync="pageNum"
        :total="total"
      >
      </el-pagination>
    </div>
  </div>
</template>
<script>
import { selectCourse, school, courseTime, unPassState } from "@/api/cso";
import { formatDate } from "@/utils/date";

const defaultListQuery = {
  pageNum: 1,
  pageSize: 10
};
export default {
  name: "selectUnPass",
  data() {
    return {
      test1: "",
      listQuery: Object.assign({}, defaultListQuery),
      list: [],
      pageSize: null,
      pageNum: null,
      total: null,
      listLoading: true,
      multipleSelection: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            }
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            }
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            }
          }
        ]
      },
      inputTime: [],
      chatTime: [],
      paymentTime: [],
      schoolList: [],
      courseTimeList: [],
      passStateList: [
        {
          value: 1,
          label: "全部信息待确认"
        },
        {
          value: 2,
          label: "转学分待确认"
        },
        {
          value: 3,
          label: "已转学分"
        }
      ],
      isLopFile: false,
      isCreditFile: false,
      // checked: false,
      checkList: []
      //   showConfirm: true
    };
  },
  // computed: {
  //   starInputTime() {
  //     return this.inputTime[0]
  //   },
  //   endInputTime() {
  //     return this.inputTime[1]
  //   }
  // },
  watch: {
    inputTime(newValue, oldValue) {
      if (this.inputTime) {
        [
          this.listQuery.starAllocateTime,
          this.listQuery.endAllocateTime
        ] = this.inputTime;
      } else {
        this.listQuery.starAllocateTime = undefined;
        this.listQuery.endAllocateTime = undefined;
      }
    },
    chatTime(newValue, oldValue) {
      if (this.chatTime) {
        [
          this.listQuery.starChatTime,
          this.listQuery.endChatTime
        ] = this.chatTime;
      } else {
        this.listQuery.starChatTime = undefined;
        this.listQuery.endChatTime = undefined;
      }
    },
    paymentTime(newValue, oldValue) {
      if (this.paymentTime) {
        [
          this.listQuery.starPaymentTime,
          this.listQuery.endPaymentTime
        ] = this.paymentTime;
      } else {
        this.listQuery.starPaymentTime = undefined;
        this.listQuery.endPaymentTime = undefined;
      }
    }
  },
  filters: {
    formatDateTime(time) {
      if (time == null || time === "") {
        return "N/A";
      }
      let date = new Date(time);
      // return formatDate(date, "yyyy-MM-dd hh:mm:ss");
      return formatDate(date, "yyyy-MM-dd");
    }
  },
  created() {
    this.getData();
    this.getSchool();
    this.getCourseTime();
  },

  methods: {
    test(aa) {
      if (this.userStatus == "") {
        this.userStatus = undefined;
      }
    },
    getData() {
      this.listLoading = true;
      selectCourse(3, this.listQuery).then(res => {
        this.listLoading = false;

        // this.list = res.data.list;
        this.pageNum = res.data.pageNum;
        this.pageSize = res.data.pageSize;
        this.total = res.data.total;
        // this.showConfirm =
        res.data.list.forEach(item => {
          let res = item.userCourseList.every(val => {
            return val.state !== 2;
          });
          item.showConfirmDisabled = res;
          //   console.log(res, "res666");
        });
        // console.log(this.showConfirm, "this.showConfirm");
        // res.data.list.forEach(item => {
        //   item.checkList = [];
        //   item.userCourseList.forEach(val => {
        //     val.state = "";
        //     // val.checkList = [];
        //   });
        //   //   item.userCourseList.checked = false;
        // });
        this.list = JSON.parse(JSON.stringify(res.data.list));
        console.log(this.list, "this.list");
        this.$forceUpdate();
      });
    },
    getSchool() {
      school().then(res => {
        // this.schoolList = res.data;
        // console.log(this.schoolList, "this.schoolList");
        res.data.forEach(item => {
          let obj = {};
          obj.value = item;
          obj.label = item;
          this.schoolList.push(obj);
        });
      });
    },
    getCourseTime() {
      courseTime().then(res => {
        res.data.forEach(item => {
          let obj = {};
          obj.value = item;
          obj.label = item;
          this.courseTimeList.push(obj);
        });
      });
    },

    handleSearchList() {
      //搜索
      this.listQuery.pageNum = 1;
      this.getData();
    },
    handleAddProduct() {
      // 添加
      this.$router.push({ path: "/pms/addProduct" });
    },
    handleStuDetail(id) {
      // 测试用的
      this.$router.push({
        path: "/pms/stuDetail",
        query: {
          id: id
        }
      });
      // console.log(123);
    },

    handleCurrentChange(val) {
      // 翻页
      this.listQuery.pageNum = val;
      this.getData();
    },
    handleSizeChange(val) {
      //切换展示条数
      this.listQuery.pageSize = val;
      this.getData();
    },

    handleResetSearch(formName) {
      this.$refs[formName].resetFields();
      // 重置
      // this.selectProductCateValue = [];
      this.inputTime = undefined;
      this.isCreditFile = false;
      this.isLopFile = false;
      // this.chatTime = undefined;
      // this.paymentTime = undefined;
      this.listQuery = Object.assign({}, defaultListQuery);
      this.getData();
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    changeTableSort(column) {
      console.log("prop", column.prop);
      console.log("order", column.order);
      // console.log("column", column);
      if (column.prop == "nextChatTime") {
        this.listQuery.secondSort = null;
        if (column.order == "ascending") {
          this.listQuery.firstSort = 0;
        } else if (column.order == "descending") {
          this.listQuery.firstSort = 1;
        }
      }
      // if (column.prop == "nextChatTime") {
      //   this.listQuery.firstSort = null;
      //   if (column.order == "ascending") {
      //     this.listQuery.secondSort = 0;
      //   } else if (column.order == "descending") {
      //     this.listQuery.secondSort = 1;
      //   }
      // }
      if (column.order == null) {
        this.listQuery.secondSort = this.listQuery.firstSort = null;
      }
      this.getData();
      console.log("changeTableSort");
    },
    confirm(userCourseList, state) {
      // console.log(userCourseList, state, "userCourseList,state");
      let arr = [];
      userCourseList.forEach(item => {
        arr.push(item.id);
      });
      // console.log(arr, state, "arr,state)");
      if (!state) {
        this.$message({
          type: "error",
          message: "请选择学员状态",
          duration: 1000
        });
      } else {
        this.$confirm("是否要确认", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(res => {
          unPassState({
            state,
            userCourseIds: arr
          }).then(res => {
            this.$message({
              type: "success",
              message: "提交成功",
              duration: 1000
            });

            this.getData();
            this.$forceUpdate();
          });
        });
      }
    }
  }
};
</script>
<style lang="scss" scoped>
.handleStuDetail {
  cursor: pointer;
}
.selectClass {
  display: flex;
  align-items: center;
  .el-select {
    width: 100px;
  }
}
</style>
